<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "https://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=11"/>
<meta name="generator" content="Doxygen 1.9.3"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>My Project: include/tile/RoadTile.hpp Source File</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr id="projectrow">
  <td id="projectalign">
   <div id="projectname">My Project
   </div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.9.3 -->
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:d3d9a9a6595521f9666a5e94cc830dab83b65699&amp;dn=expat.txt MIT */
var searchBox = new SearchBox("searchBox", "search",'Search','.html');
/* @license-end */
</script>
<script type="text/javascript" src="menudata.js"></script>
<script type="text/javascript" src="menu.js"></script>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:d3d9a9a6595521f9666a5e94cc830dab83b65699&amp;dn=expat.txt MIT */
$(function() {
  initMenu('',true,false,'search.php','Search');
  $(document).ready(function() { init_search(); });
});
/* @license-end */
</script>
<div id="main-nav"></div>
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div id="nav-path" class="navpath">
  <ul>
<li class="navelem"><a class="el" href="dir_d44c64559bbebec7f509842c48db8b23.html">include</a></li><li class="navelem"><a class="el" href="dir_f656290b9017852ece87b8a3712178e6.html">tile</a></li>  </ul>
</div>
</div><!-- top -->
<div class="header">
  <div class="headertitle"><div class="title">RoadTile.hpp</div></div>
</div><!--header-->
<div class="contents">
<a href="RoadTile_8hpp.html">Go to the documentation of this file.</a><div class="fragment"><div class="line"><a id="l00001" name="l00001"></a><span class="lineno">    1</span><span class="preprocessor">#pragma once</span></div>
<div class="line"><a id="l00002" name="l00002"></a><span class="lineno">    2</span> </div>
<div class="line"><a id="l00003" name="l00003"></a><span class="lineno">    3</span><span class="preprocessor">#include &quot;<a class="code" href="Tile_8hpp.html">Tile.hpp</a>&quot;</span></div>
<div class="line"><a id="l00004" name="l00004"></a><span class="lineno">    4</span><span class="preprocessor">#include &lt;SFML/Graphics.hpp&gt;</span></div>
<div class="line"><a id="l00005" name="l00005"></a><span class="lineno">    5</span><span class="preprocessor">#include &lt;<a class="code" href="Attributes_8hpp.html">resources/Attributes.hpp</a>&gt;</span></div>
<div class="line"><a id="l00006" name="l00006"></a><span class="lineno">    6</span> </div>
<div class="line"><a id="l00007" name="l00007"></a><span class="lineno">    7</span><span class="preprocessor">#include &lt;string&gt;</span></div>
<div class="line"><a id="l00008" name="l00008"></a><span class="lineno">    8</span> </div>
<div class="line"><a id="l00009" name="l00009"></a><span class="lineno">    9</span><span class="keyword">namespace </span><a class="code hl_namespace" href="namespacegg.html">gg</a></div>
<div class="line"><a id="l00010" name="l00010"></a><span class="lineno">   10</span>{</div>
<div class="line"><a id="l00011" name="l00011"></a><span class="lineno"><a class="line" href="namespacegg.html#a59e8f774a3ab30332c9369908203b584">   11</a></span><span class="keyword">enum class</span> <a class="code hl_enumeration" href="namespacegg.html#a59e8f774a3ab30332c9369908203b584">RoadType</a> {</div>
<div class="line"><a id="l00012" name="l00012"></a><span class="lineno">   12</span>    <a class="code hl_enumvalue" href="namespacegg.html#a59e8f774a3ab30332c9369908203b584aa75a1789547188e39e2e344c286d2b62">BRIDGE</a>,</div>
<div class="line"><a id="l00013" name="l00013"></a><span class="lineno">   13</span>    <a class="code hl_enumvalue" href="namespacegg.html#a59e8f774a3ab30332c9369908203b584ac1f99946759b3b77f47f5e7226f66d90">BRIDGE2</a>,</div>
<div class="line"><a id="l00014" name="l00014"></a><span class="lineno">   14</span>    <a class="code hl_enumvalue" href="namespacegg.html#a59e8f774a3ab30332c9369908203b584a8c5e50fab3748e9c53a6863b3dce1401">STRAIGHT</a>,</div>
<div class="line"><a id="l00015" name="l00015"></a><span class="lineno">   15</span>    <a class="code hl_enumvalue" href="namespacegg.html#a59e8f774a3ab30332c9369908203b584ab1a326c06d88bf042f73d70f50197905">END</a>,</div>
<div class="line"><a id="l00016" name="l00016"></a><span class="lineno">   16</span>    <a class="code hl_enumvalue" href="namespacegg.html#a59e8f774a3ab30332c9369908203b584a04dd53a8e6c2306e9bbf944c1d6047f2">CROSS</a>,</div>
<div class="line"><a id="l00017" name="l00017"></a><span class="lineno">   17</span>    <a class="code hl_enumvalue" href="namespacegg.html#a59e8f774a3ab30332c9369908203b584ac4e0e4e3118472beeb2ae75827450f1f">DOWN</a>,</div>
<div class="line"><a id="l00018" name="l00018"></a><span class="lineno">   18</span>    <a class="code hl_enumvalue" href="namespacegg.html#a59e8f774a3ab30332c9369908203b584ab9ece18c950afbfa6b0fdbfa4ff731d3">T</a>,</div>
<div class="line"><a id="l00019" name="l00019"></a><span class="lineno">   19</span>    <a class="code hl_enumvalue" href="namespacegg.html#a59e8f774a3ab30332c9369908203b584ac38d71ccb456d48250ed9b99255384d2">CROSSROAD</a></div>
<div class="line"><a id="l00020" name="l00020"></a><span class="lineno">   20</span>};</div>
<div class="line"><a id="l00021" name="l00021"></a><span class="lineno">   21</span> </div>
<div class="line"><a id="l00022" name="l00022"></a><span class="lineno"><a class="line" href="classgg_1_1RoadTile.html">   22</a></span><span class="keyword">class </span><a class="code hl_class" href="classgg_1_1RoadTile.html">RoadTile</a> : <span class="keyword">public</span> <a class="code hl_class" href="classgg_1_1Tile.html">Tile</a></div>
<div class="line"><a id="l00023" name="l00023"></a><span class="lineno">   23</span>{</div>
<div class="line"><a id="l00024" name="l00024"></a><span class="lineno">   24</span>  <span class="keyword">public</span>:</div>
<div class="line"><a id="l00025" name="l00025"></a><span class="lineno"><a class="line" href="classgg_1_1RoadTile.html#ad21572aaab4d3e430d69932e1888d1ce">   25</a></span>    <a class="code hl_function" href="classgg_1_1RoadTile.html#ad21572aaab4d3e430d69932e1888d1ce">RoadTile</a>(<a class="code hl_class" href="classgg_1_1Attributes.html">Attributes</a> &amp;attributes);</div>
<div class="line"><a id="l00026" name="l00026"></a><span class="lineno"><a class="line" href="classgg_1_1RoadTile.html#a7d58b7500a42f402ce02d20068799c8c">   26</a></span>    <a class="code hl_function" href="classgg_1_1RoadTile.html#a7d58b7500a42f402ce02d20068799c8c">~RoadTile</a>() <span class="keyword">override</span> = <span class="keywordflow">default</span>;</div>
<div class="line"><a id="l00027" name="l00027"></a><span class="lineno">   27</span> </div>
<div class="line"><a id="l00028" name="l00028"></a><span class="lineno"><a class="line" href="classgg_1_1RoadTile.html#a6626a61ed9975c915342765bcb286eb5">   28</a></span>    <span class="keywordtype">void</span> <a class="code hl_function" href="classgg_1_1RoadTile.html#a6626a61ed9975c915342765bcb286eb5">Update</a>() <span class="keyword">override</span>;</div>
<div class="line"><a id="l00029" name="l00029"></a><span class="lineno"><a class="line" href="classgg_1_1RoadTile.html#a47484c6394f6d8c0c42ed12d200853a6">   29</a></span>    <span class="keywordtype">void</span> <a class="code hl_function" href="classgg_1_1RoadTile.html#a47484c6394f6d8c0c42ed12d200853a6">SetType</a>(<span class="keyword">const</span> <a class="code hl_enumeration" href="namespacegg.html#a59e8f774a3ab30332c9369908203b584">RoadType</a> &amp;type);</div>
<div class="line"><a id="l00030" name="l00030"></a><span class="lineno"><a class="line" href="classgg_1_1RoadTile.html#a7092834f52949943206ab6f48cd813c9">   30</a></span>    <span class="keyword">auto</span> <a class="code hl_function" href="classgg_1_1RoadTile.html#a7092834f52949943206ab6f48cd813c9">GetType</a>() -&gt; <a class="code hl_enumeration" href="namespacegg.html#a59e8f774a3ab30332c9369908203b584">RoadType</a>;</div>
<div class="line"><a id="l00031" name="l00031"></a><span class="lineno"><a class="line" href="classgg_1_1RoadTile.html#a512b2a92537e1479161dbf2e9855f3b3">   31</a></span>    <span class="keyword">auto</span> <a class="code hl_function" href="classgg_1_1RoadTile.html#a512b2a92537e1479161dbf2e9855f3b3">GetCost</a>() -&gt; unsigned;</div>
<div class="line"><a id="l00032" name="l00032"></a><span class="lineno">   32</span> </div>
<div class="line"><a id="l00033" name="l00033"></a><span class="lineno"><a class="line" href="classgg_1_1RoadTile.html#a9ad4e5d521981d13a434bafe519ba647">   33</a></span>    <span class="keyword">auto</span> <a class="code hl_function" href="classgg_1_1RoadTile.html#a9ad4e5d521981d13a434bafe519ba647">GetAttributes</a>() -&gt; <a class="code hl_class" href="classgg_1_1Attributes.html">Attributes</a> <span class="keyword">override</span>;</div>
<div class="line"><a id="l00034" name="l00034"></a><span class="lineno"><a class="line" href="classgg_1_1RoadTile.html#ac2a5ee73935690e23027dd05ddc41cd9">   34</a></span>    <span class="keyword">auto</span> <a class="code hl_function" href="classgg_1_1RoadTile.html#ac2a5ee73935690e23027dd05ddc41cd9">GetTileType</a>() -&gt; <a class="code hl_enumeration" href="namespacegg.html#a08ccf34451b5441314600ac46113a9f6">TileType</a> <span class="keyword">override</span>;</div>
<div class="line"><a id="l00035" name="l00035"></a><span class="lineno">   35</span> </div>
<div class="line"><a id="l00036" name="l00036"></a><span class="lineno"><a class="line" href="classgg_1_1RoadTile.html#aeedb625034bf25912bcd7cf1b0c06f6d">   36</a></span>    <span class="keyword">static</span> <span class="keyword">auto</span> <a class="code hl_function" href="classgg_1_1RoadTile.html#aeedb625034bf25912bcd7cf1b0c06f6d">RoadTypeToString</a>(<span class="keyword">const</span> <a class="code hl_enumeration" href="namespacegg.html#a59e8f774a3ab30332c9369908203b584">RoadType</a> type) -&gt; std::string;</div>
<div class="line"><a id="l00037" name="l00037"></a><span class="lineno"><a class="line" href="classgg_1_1RoadTile.html#a22a870ddb0813ecdfc7b51e6409eb701">   37</a></span>    <span class="keyword">static</span> <span class="keyword">auto</span> <a class="code hl_function" href="classgg_1_1RoadTile.html#a22a870ddb0813ecdfc7b51e6409eb701">StringToRoadType</a>(<span class="keyword">const</span> std::string &amp;str) -&gt; <a class="code hl_enumeration" href="namespacegg.html#a59e8f774a3ab30332c9369908203b584">RoadType</a>;</div>
<div class="line"><a id="l00038" name="l00038"></a><span class="lineno">   38</span> </div>
<div class="line"><a id="l00039" name="l00039"></a><span class="lineno"><a class="line" href="classgg_1_1RoadTile.html#a70b6f3f75aecc8a3c7a4d68e928ee7af">   39</a></span>    <span class="keywordtype">void</span> <a class="code hl_function" href="classgg_1_1RoadTile.html#a70b6f3f75aecc8a3c7a4d68e928ee7af">Align</a>() <span class="keyword">override</span>;</div>
<div class="line"><a id="l00040" name="l00040"></a><span class="lineno">   40</span> </div>
<div class="line"><a id="l00041" name="l00041"></a><span class="lineno">   41</span>  <span class="keyword">private</span>:</div>
<div class="line"><a id="l00042" name="l00042"></a><span class="lineno">   42</span>    <a class="code hl_enumeration" href="namespacegg.html#a59e8f774a3ab30332c9369908203b584">RoadType</a> mType;</div>
<div class="line"><a id="l00043" name="l00043"></a><span class="lineno">   43</span>    <span class="keywordtype">unsigned</span> mCost;</div>
<div class="line"><a id="l00044" name="l00044"></a><span class="lineno">   44</span>};</div>
<div class="line"><a id="l00045" name="l00045"></a><span class="lineno">   45</span>}; <span class="comment">// namespace gg</span></div>
<div class="ttc" id="aAttributes_8hpp_html"><div class="ttname"><a href="Attributes_8hpp.html">Attributes.hpp</a></div></div>
<div class="ttc" id="aTile_8hpp_html"><div class="ttname"><a href="Tile_8hpp.html">Tile.hpp</a></div></div>
<div class="ttc" id="aclassgg_1_1Attributes_html"><div class="ttname"><a href="classgg_1_1Attributes.html">gg::Attributes</a></div><div class="ttdef"><b>Definition:</b> Attributes.hpp:14</div></div>
<div class="ttc" id="aclassgg_1_1RoadTile_html"><div class="ttname"><a href="classgg_1_1RoadTile.html">gg::RoadTile</a></div><div class="ttdef"><b>Definition:</b> RoadTile.hpp:23</div></div>
<div class="ttc" id="aclassgg_1_1RoadTile_html_a22a870ddb0813ecdfc7b51e6409eb701"><div class="ttname"><a href="classgg_1_1RoadTile.html#a22a870ddb0813ecdfc7b51e6409eb701">gg::RoadTile::StringToRoadType</a></div><div class="ttdeci">static auto StringToRoadType(const std::string &amp;str) -&gt; RoadType</div></div>
<div class="ttc" id="aclassgg_1_1RoadTile_html_a47484c6394f6d8c0c42ed12d200853a6"><div class="ttname"><a href="classgg_1_1RoadTile.html#a47484c6394f6d8c0c42ed12d200853a6">gg::RoadTile::SetType</a></div><div class="ttdeci">void SetType(const RoadType &amp;type)</div></div>
<div class="ttc" id="aclassgg_1_1RoadTile_html_a512b2a92537e1479161dbf2e9855f3b3"><div class="ttname"><a href="classgg_1_1RoadTile.html#a512b2a92537e1479161dbf2e9855f3b3">gg::RoadTile::GetCost</a></div><div class="ttdeci">auto GetCost() -&gt; unsigned</div></div>
<div class="ttc" id="aclassgg_1_1RoadTile_html_a6626a61ed9975c915342765bcb286eb5"><div class="ttname"><a href="classgg_1_1RoadTile.html#a6626a61ed9975c915342765bcb286eb5">gg::RoadTile::Update</a></div><div class="ttdeci">void Update() override</div></div>
<div class="ttc" id="aclassgg_1_1RoadTile_html_a7092834f52949943206ab6f48cd813c9"><div class="ttname"><a href="classgg_1_1RoadTile.html#a7092834f52949943206ab6f48cd813c9">gg::RoadTile::GetType</a></div><div class="ttdeci">auto GetType() -&gt; RoadType</div></div>
<div class="ttc" id="aclassgg_1_1RoadTile_html_a70b6f3f75aecc8a3c7a4d68e928ee7af"><div class="ttname"><a href="classgg_1_1RoadTile.html#a70b6f3f75aecc8a3c7a4d68e928ee7af">gg::RoadTile::Align</a></div><div class="ttdeci">void Align() override</div></div>
<div class="ttc" id="aclassgg_1_1RoadTile_html_a7d58b7500a42f402ce02d20068799c8c"><div class="ttname"><a href="classgg_1_1RoadTile.html#a7d58b7500a42f402ce02d20068799c8c">gg::RoadTile::~RoadTile</a></div><div class="ttdeci">~RoadTile() override=default</div></div>
<div class="ttc" id="aclassgg_1_1RoadTile_html_a9ad4e5d521981d13a434bafe519ba647"><div class="ttname"><a href="classgg_1_1RoadTile.html#a9ad4e5d521981d13a434bafe519ba647">gg::RoadTile::GetAttributes</a></div><div class="ttdeci">auto GetAttributes() -&gt; Attributes override</div></div>
<div class="ttc" id="aclassgg_1_1RoadTile_html_ac2a5ee73935690e23027dd05ddc41cd9"><div class="ttname"><a href="classgg_1_1RoadTile.html#ac2a5ee73935690e23027dd05ddc41cd9">gg::RoadTile::GetTileType</a></div><div class="ttdeci">auto GetTileType() -&gt; TileType override</div></div>
<div class="ttc" id="aclassgg_1_1RoadTile_html_ad21572aaab4d3e430d69932e1888d1ce"><div class="ttname"><a href="classgg_1_1RoadTile.html#ad21572aaab4d3e430d69932e1888d1ce">gg::RoadTile::RoadTile</a></div><div class="ttdeci">RoadTile(Attributes &amp;attributes)</div></div>
<div class="ttc" id="aclassgg_1_1RoadTile_html_aeedb625034bf25912bcd7cf1b0c06f6d"><div class="ttname"><a href="classgg_1_1RoadTile.html#aeedb625034bf25912bcd7cf1b0c06f6d">gg::RoadTile::RoadTypeToString</a></div><div class="ttdeci">static auto RoadTypeToString(const RoadType type) -&gt; std::string</div></div>
<div class="ttc" id="aclassgg_1_1Tile_html"><div class="ttname"><a href="classgg_1_1Tile.html">gg::Tile</a></div><div class="ttdef"><b>Definition:</b> Tile.hpp:21</div></div>
<div class="ttc" id="anamespacegg_html"><div class="ttname"><a href="namespacegg.html">gg</a></div><div class="ttdef"><b>Definition:</b> Application.hpp:22</div></div>
<div class="ttc" id="anamespacegg_html_a08ccf34451b5441314600ac46113a9f6"><div class="ttname"><a href="namespacegg.html#a08ccf34451b5441314600ac46113a9f6">gg::TileType</a></div><div class="ttdeci">TileType</div><div class="ttdef"><b>Definition:</b> Tile.hpp:11</div></div>
<div class="ttc" id="anamespacegg_html_a59e8f774a3ab30332c9369908203b584"><div class="ttname"><a href="namespacegg.html#a59e8f774a3ab30332c9369908203b584">gg::RoadType</a></div><div class="ttdeci">RoadType</div><div class="ttdef"><b>Definition:</b> RoadTile.hpp:11</div></div>
<div class="ttc" id="anamespacegg_html_a59e8f774a3ab30332c9369908203b584a04dd53a8e6c2306e9bbf944c1d6047f2"><div class="ttname"><a href="namespacegg.html#a59e8f774a3ab30332c9369908203b584a04dd53a8e6c2306e9bbf944c1d6047f2">gg::RoadType::CROSS</a></div><div class="ttdeci">@ CROSS</div></div>
<div class="ttc" id="anamespacegg_html_a59e8f774a3ab30332c9369908203b584a8c5e50fab3748e9c53a6863b3dce1401"><div class="ttname"><a href="namespacegg.html#a59e8f774a3ab30332c9369908203b584a8c5e50fab3748e9c53a6863b3dce1401">gg::RoadType::STRAIGHT</a></div><div class="ttdeci">@ STRAIGHT</div></div>
<div class="ttc" id="anamespacegg_html_a59e8f774a3ab30332c9369908203b584aa75a1789547188e39e2e344c286d2b62"><div class="ttname"><a href="namespacegg.html#a59e8f774a3ab30332c9369908203b584aa75a1789547188e39e2e344c286d2b62">gg::RoadType::BRIDGE</a></div><div class="ttdeci">@ BRIDGE</div></div>
<div class="ttc" id="anamespacegg_html_a59e8f774a3ab30332c9369908203b584ab1a326c06d88bf042f73d70f50197905"><div class="ttname"><a href="namespacegg.html#a59e8f774a3ab30332c9369908203b584ab1a326c06d88bf042f73d70f50197905">gg::RoadType::END</a></div><div class="ttdeci">@ END</div></div>
<div class="ttc" id="anamespacegg_html_a59e8f774a3ab30332c9369908203b584ab9ece18c950afbfa6b0fdbfa4ff731d3"><div class="ttname"><a href="namespacegg.html#a59e8f774a3ab30332c9369908203b584ab9ece18c950afbfa6b0fdbfa4ff731d3">gg::RoadType::T</a></div><div class="ttdeci">@ T</div></div>
<div class="ttc" id="anamespacegg_html_a59e8f774a3ab30332c9369908203b584ac1f99946759b3b77f47f5e7226f66d90"><div class="ttname"><a href="namespacegg.html#a59e8f774a3ab30332c9369908203b584ac1f99946759b3b77f47f5e7226f66d90">gg::RoadType::BRIDGE2</a></div><div class="ttdeci">@ BRIDGE2</div></div>
<div class="ttc" id="anamespacegg_html_a59e8f774a3ab30332c9369908203b584ac38d71ccb456d48250ed9b99255384d2"><div class="ttname"><a href="namespacegg.html#a59e8f774a3ab30332c9369908203b584ac38d71ccb456d48250ed9b99255384d2">gg::RoadType::CROSSROAD</a></div><div class="ttdeci">@ CROSSROAD</div></div>
<div class="ttc" id="anamespacegg_html_a59e8f774a3ab30332c9369908203b584ac4e0e4e3118472beeb2ae75827450f1f"><div class="ttname"><a href="namespacegg.html#a59e8f774a3ab30332c9369908203b584ac4e0e4e3118472beeb2ae75827450f1f">gg::RoadType::DOWN</a></div><div class="ttdeci">@ DOWN</div></div>
</div><!-- fragment --></div><!-- contents -->
<!-- start footer part -->
<hr class="footer"/><address class="footer"><small>
Generated by&#160;<a href="https://www.doxygen.org/index.html"><img class="footer" src="doxygen.svg" width="104" height="31" alt="doxygen"/></a> 1.9.3
</small></address>
</body>
</html>
